@echo off

:: Copyright (c) 2011, Intel Corporation
:: All rights reserved.
::  
:: Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
:: 
::     * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
::     * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
::     * Neither the name of Intel Corporation nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
:: 
:: THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

if not exist %~dp0..\..\..\inc\settings.bat (
 echo Missing %~dp0..\..\..\inc\settings.bat.
 goto end
)

call %~dp0..\..\..\inc\settings.bat

:: Check for temp dir
SET TMP_DIR=%~dp0..\..\..\tmp\
SET MNT_DIR=%~dp0..\..\..\tmp\mount\
if not exist %MNT_DIR% (
 echo Image not mounted
 goto end 
)
:: Make the temp directory structure
set WKDIR=%TMP_DIR%OS_Image\%arch%\
if not exist %WKDIR% (
 echo Unable to find working directory.
 goto end
)
:: Allow user to answer Qs
::if exist %WKDIR%windows\system32\osi_settings.bat goto copy_files
copy %~dp0OS_image.hta %WKDIR%windows\system32\
copy %~dp0settings.xml %WKDIR%windows\system32\
copy %~dp0os_image.vbs %WKDIR%windows\system32\
copy %~dp0..\..\..\inc\default.css %WKDIR%windows\system32\
:: Add HTA Support
Dism /image:%MNT_DIR% /Add-Package /PackagePath:"%TMP_DIR%WinPE_FPs\%arch%\WinPE_FPs\winpe-hta.cab" 
if not %ERRORLEVEL%==0 (
 echo Unable to apply HTA package.
 goto end
)
Dism /image:%MNT_DIR% /Add-Package /PackagePath:"%TMP_DIR%WinPE_FPs\%arch%\WinPE_FPs\%LANG%\winpe-hta_%LANG%.cab"
if not %ERRORLEVEL%==0 (
 echo Unable to apply HTA package.
 goto end
)

:copy_files
:: Copy in included code
xcopy /cherky %WKDIR%*.* %MNT_DIR%
if not %ERRORLEVEL%==0 (
 echo Unable to apply OS Image Package.
 goto end
)

:: Add start OS Image command to WinPE
echo call OS_Image.bat >> %MNT_DIR%windows\system32\startnet3.cmd

echo Success
:end